      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8) OPTION(*EVENTF) TGTRLS(V5R3M0)
      * ---------------------------------------------------------------
      * Module.....: XV0075_M01       Project.....:
      * Author.....: Alan Campin      Date written: 03/19/2011
      * Purpose....: CPP for FTPOBJ. Loop through list of objects and validate
      *                existance and authority to save. Then submit to batch
      *                to do actual transfers.
      * ---------------------------------------------------------------
      * Called by..: FTPOBJ
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
     h Option(*Srcstmt:*Nodebugio:*NoShowCpy)

      /copy *libl/qsrcf,cb_stdtypx
      /copy *libl/qsrcf,cb_std_con

      /copy *libl/qsrcf,xverrh_pr

     d ProgramEntrance...
     d                 pr                  ExtPgm('XV0075')
     d   PR_InNumberOfObjects...
     d                                     Like(StdIntSml)
     d   PR_InHowToProcess...
     d                                     Like(StdChr)

     d ProcessList...
     d                 pr
     d   PR_InNumberOfObjects...
     d                                     Like(StdIntSml)
     d   PR_InHowToProcess...
     d                                     Like(StdChr)

     d TD_Object...
     d                 ds                  Qualified
     d                                     Based(StdNullPtr)
     d   NumberOfElements...
     d                                     Like(StdIntSml)
     d   ObjectName...
     d                                     LikeDS(TD_QualifiedName)
     d   ObjectType...
     d                                     Like(StdNam)
     d   TransferToLibrary...
     d                                     Like(StdNam)

     d FTP_Parms...
     d                 ds                  DtaAra(FTPOBJ_PRM)
     d   SystemId...
     d                                1a
     d   RunNumber...
     d                                4s 0
     d   TransferToSystemName...
     d                               10a

     d ProgramEntrance...
     d                 pi
     d   InNumberOfObjects...
     d                                     Like(StdIntSml)
     d   InHowToProcess...
     d                                     Like(StdChr)
      /Free

       ProcessList(InNumberOfObjects:
                   InHowToProcess   );

       *InLR = *On;

      /End-Free
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * ProcessList
      *   This function process a list of objects.
      *       Input       - Object List
      *                       Note: Lists are passed as:
      *                               Number of object passed-Small Integer
      *                               Offset to object * Number of objects-Small Integer
      *                               Object List   - First object on list on input is last on list
      *                                 Number of elements-Small Integer
      *                                 Object Name
      *                                 Object Library
      *                                 Object Type
      *                     How to process. Batch or Interactive.
      *       Out         - None
      *       In/Out  -
      *       Returns - None
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p ProcessList...
     p                 b
     d                 pi
     d   InNumberOfObjects...
     d                                     Like(StdIntSml)
     d   InHowToProcess...
     d                                     Like(StdChr)

     d Object...
     d                 ds                  LikeDs(TD_Object)
     d                                     Based(ptrObject)

     d ValidateObject...
     d                 pr                  ExtProc('XV0075_M02')
     d   PR_ObjectName...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_ObjectLibrary...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_ObjectType...
     d                                     Like(StdNam)
     d                                     Const

     d RunTransfer...
     d                 pr                  ExtProc('XV0075_M03')
     d   PR_HowToProcess...
     d                                     Like(StdChr)
     d                                     Const
     d   PR_ObjectName...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_ObjectLibrary...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_ObjectType...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_TransferToLibrary...
     d                                     Like(StdNam)
     d                                     Const
     d   PR_RunNumber...
     d                                4p 0 Const
     d   PR_ToSystemId...
     d                                     Like(StdChr)
     d                                     Const
     d   PR_ToSystemName...
     d                               10a   Const
     d   PR_TransferNumber...
     d                                3p 0 Const

     d x...
     d                 s                   Like(StdInt)
     d Offset...
     d                 s                   Like(StdIntSml)
     d                                     Based(ptrOffset)
     d TransferNumber...
     d                 s              3p 0
      /Free

       // Get the run number.
       In *Lock FTP_Parms;
       FTP_Parms.RunNumber += 1;
       Out FTP_Parms;

       For x = 1 To InNumberOfObjects;
         ptrOffset = %Addr(InNumberOfObjects) +
                        %Size(InNumberOfObjects) +
                        ((x - 1) * %Size(Offset));
         ptrObject = %Addr(InNumberOfObjects) + Offset;
         Monitor;
           ValidateObject(Object.ObjectName.Name   :
                          Object.ObjectName.Library:
                          Object.ObjectType        );
         On-Error;
           ERRH_Throw('CPF9898':
                      cCPFMessageFileName:
                      'Validation failed! See low level messages');
         EndMon;

         TransferNumber += 1;
         RunTransfer(InHowToProcess                :
                     Object.ObjectName.Name        :
                     Object.ObjectName.Library     :
                     Object.ObjectType             :
                     Object.TransferToLibrary      :
                     FTP_Parms.RunNumber           :
                     FTP_Parms.SystemId            :
                     FTP_Parms.TransferToSystemName:
                     TransferNumber                );
       EndFor;

       *InLR = *On;

       Return;

      /End-Free
     p                 e
